// boutton principaux
@mixin btn{
    position: relative;
    z-index: 1;
    padding: 1.7rem 2rem;
    border: none;
    background: none;
    overflow: hidden;
    font-size: 1.4rem;
    font-weight: 500;
    text-align: center;
    border-radius: 2.5rem;
    color: $color-white;
    background-image: $color-gradient;
    box-shadow: $shadow;
    transition: box-shadow 300ms ease-in-out;
    &::before{
        content: '';
        position: absolute;
        width: 100%;
        height: 100%;
        top: 0;
        left: 0;
        z-index: -1;
        background-image: $color-gradient-hover;
        opacity: 0;
        transition: opacity 200ms ease-in-out 50ms;
    }
    &:hover{
        box-shadow: $shadow-hover;
        &::before{
            opacity: 1;
        }
    } 
}

// bouton ajouter restaurant
@mixin btnHeart{
    position:relative;
    width:2.5rem;
    height:2.5rem;
    min-height: 2.5rem;
    & span{
        display: block;
        width:2.5rem;
        height:2.5rem;
        min-height: 2.5rem;
        text-align: center;
        line-height: 2.5rem;
    }
    &__inactif{
        font-size: 2rem; 
        color: $color-black;
        transition: color 300ms ease-in-out 50ms;
    }
    &__actif{
        font-size: 1.8rem;
        position:absolute;
        top:.2rem;
        left:0rem;
        color: $color-primaire;
        transform: scale(0);
        transition: all 500ms cubic-bezier(.76,.24,.16,.27) 0ms;
        .fas{
            display: block;
            background: $color-gradient-hover;
            -webkit-background-clip: text;
            -webkit-text-fill-color: transparent;
        } 
    }
    &:hover{
        .btnHeart__inactif{
            transform: scale(1);
            color: $color-secondaire;
        }
        .btnHeart__actif{
            transform: scale(1);
        }
    }
}

// icon Nouveau
@mixin btnNew($colorButton:$color-tertiaire){
    padding: .5rem 1rem;
    border-radius: .2rem;
    border: none;
    overflow: hidden;
    background-color: $colorButton;
    color: darken($colorButton , 50); 
}

// perso underline
@mixin underline($width , $height , $bgColor){
    &::after{
        display: block;
        content:'';
        width: $width;
        height: $height;
        background-color: $bgColor; 
    }
}


@mixin animate-wait{
    $overlay-duration :  $anime-waiting-duration; // __vars.scss
    $loadBarre-duration : $anime-waiting-duration * 0.95; // duree barre chargment (95% anime)
    $log-duration : $loadBarre-duration; // temps affichage message sur barre chargement
    
    $listStep-duration : $loadBarre-duration;
    // occupation du temps par fonctionement
    $step-duration : $listStep-duration / 3;
    $step-delay : 0ms; // init delay

    &{
        animation: waiting-overlay  $overlay-duration ease-in-out both;
        &__barre{
            & > div::before{ // barre de chargment
                animation: waiting-barre $loadBarre-duration ease-in-out both;
            }
            & > div::after{ // message dans la barre
                animation: waiting_log $log-duration ease-in-out both;
            }
        }
        &__fonctionnement{
            @for $i from 1 through 3 {
                & .stepFonctionnement:nth-child(#{$i}){
                    animation: waiting_step $step-duration ease-in-out $step-delay both;
                }
                $step-delay : $step-delay +  ($step-duration / 2);
            }
        }
    }
}
@mixin animate-carte($template: $anime-menu-template){
    $n : 0;
    $cat-duration : $anime-menu-duration / length($template); // __vars.scss
    $cat-delay : 0ms;
    $plat-delay : 0ms;
    @each $key-cat , $nb-plat in $template {
        $plat-duration : ($cat-duration / $nb-plat) ;
        $n : $n+1;
        & .categorieMenu:nth-of-type(#{$n}){
            animation: appear-categorie $cat-duration cubic-bezier(.75,.38,.85,.51) $cat-delay both;
            & .plat{
                animation: appear-plat $plat-duration linear $cat-duration  both;
                @for $i from 1 through $nb-plat {
                    &:nth-child(#{$i}){
                        animation: appear-plat $plat-duration linear $plat-delay both; 
                    }
                    $plat-delay : $plat-delay +  $plat-duration - 20ms;
                } 
            }
        }
        $cat-delay : $cat-delay + $cat-duration - 20ms ;  
    }    
}

@mixin stepFonctionnement{
    display: flex;
    justify-content: center;
    align-items: center;
    &__num{
        width: 2.4rem;
        height: 2.4rem;
        border-radius: 50%;
        overflow: hidden;
        background-color: $color-primaire;
        color: $color-white;
        font-size: 1.3rem;
        font-weight: 600;
        text-align: center;
        line-height: 2.4rem;
        z-index:2;  
    }
    &__container{
        flex: 1;
        position: relative;
        z-index: 1;
        left: -1.2rem;
        display: flex;
        justify-content: flex-start;
        align-items: center;
        border-radius: 1.6rem;
        overflow: hidden;
        box-shadow: $shadow ;
        line-height: 2rem;
        padding: 2.4rem .1rem 2.4rem 3.5rem;
        background-color: darken($color-white,3%);
        i{
            font-size: 2rem;
            color: darken($color-white,50%);
            margin-right: 2rem;
            transition : color 350ms ease-in-out;
        }
        span{
            font-size: 1.6rem;
            font-weight: 600;
        }
        &::before{
            content: '';
            position: absolute;
            width: 100%;
            height: 100%;
            top: 0;
            left: 0;
            z-index: -1;
            background-color: lighten($color-primaire,10%);
            opacity: 0;
            transition : opacity 250ms ease-in-out 50ms;
        }
        &:hover{
            i{
                color:$color-primaire;
            }
            &::before{
                opacity:.1;
            }
        }
    }
}

@mixin container-restaurant{
    &__infos{
        flex: 1;
        display: flex;
        flex-wrap: wrap;
        justify-content: space-between;
        align-items: center;
        line-height: 2.5rem;
        padding: 1.3rem;
        & > strong{
            flex: 1;
            min-width: 70%;
            font-size: 2rem;
            font-weight: 500;
            &::first-letter{
                text-transform: capitalize;
            }
        }
        & > span{
            flex: 1;
            min-width: 70%;
            font-weight: 300;
            width: 100%;
            overflow: hidden;
            text-overflow: ellipsis;
            white-space: nowrap;
            font-size: 1.6rem;
        }
        .btnHeart{
            width:2.5rem;   
        }
    }
    &__visuel{
        height: 17rem;
        width: 100%;
        overflow: hidden;
        position: relative;
        img{
            object-fit: cover;
            object-position: center center;
            width: 100%;
            max-width: 100%;
            max-height: 100%;
        }
        .btnNew{
            position: absolute;
            top: 2rem;
            right: 2rem;
        }
    }
}
